
 rem *** a simple program to demonstrate thrust

  set zoneheight 16
  set screenheight 192
  set plotvalueonscreen on
  set romsize 32k
  set basepath gfx/

  dim playerx=a.b                 ;fixed point numbers 
  dim playery=c.d
  dim dx=e.f                     
  dim dy=g.h



  dim ship_orient=var3            ;direction ship is facing proceeding clockwise starting with 1 facing up.
  dim shipo=var4                  ;holds value of player sprite frame animation index
  dim slrot=var5                  ;slows ship rotation because the 7800 is fast baby.
  dim thrust_enabled=var6         ;flag for thrust on (1) or off (0)
  dim thrust_orient=var7          ;direction ship is moving (not same as direction ship is facing)
  dim player_color=var8           ;in AR can change ship colors somewhat. Doesn't need to be variable in this demo but holds value of the color palette we use to draw the player sprite


  rem ** setup Palette 0 (Default player ship color yellow)
  P0C1=$1B;                  yellow
  P0C2=$0E;                  white
  P0C3=$32;                  red

  incgraphic sprite_ship1.png
  incgraphic sprite_ship2.png
  incgraphic sprite_ship3.png
  incgraphic sprite_ship4.png
  incgraphic sprite_ship5.png
  incgraphic sprite_ship6.png  
  incgraphic sprite_ship7.png
  incgraphic sprite_ship8.png
  incgraphic sprite_ship1t.png
  incgraphic sprite_ship2t.png
  incgraphic sprite_ship3t.png
  incgraphic sprite_ship4t.png
  incgraphic sprite_ship5t.png
  incgraphic sprite_ship6t.png  
  incgraphic sprite_ship7t.png
  incgraphic sprite_ship8t.png
 
                                  ; Initializations
  ship_orient=3                   ; facing right 
  playerx=24
  playery=92
  player_color=0
  thrust_enabled=0                ; not thrusting

main_loop
  clearscreen

  gosub rotate

  gosub thrust

  gosub lookup_dx_dy
    
  gosub move_ship

  gosub check_boundary

  gosub display_live_player

  drawscreen

  goto main_loop


rotate
  slrot=slrot+1                               ;incriment slow rotation counter
  if slrot<8 then goto skip_rotate            ;check to see if time has passed before we rotate again
  slrot=0                                     ;reset slow rotation counter

  if joy0left  then ship_orient=ship_orient-1
  if joy0right then ship_orient=ship_orient+1 
  if ship_orient<1 then ship_orient=8         ;closes the circle of rotation left
  if ship_orient>8 then ship_orient=1         ;closes the circle of rotation right
skip_rotate
  return

thrust
    if joy0up then thrust_enabled=1: thrust_orient=ship_orient 
    if !joy0up then thrust_enabled=0
  return

;lookup_dx_dy                               ;replaced below because *100 then /100 why not just keep the decimals to start with?
 ; if thrust_orient=1 then dx=100 : dy=0    ;precalculated (calculated on a PC) acceleration vectors for each angle of rotation modeled in our game environment
 ; if thrust_orient=2 then dx=53  : dy=85
 ; if thrust_orient=3 then dx=45  : dy=89
 ; if thrust_orient=4 then dx=100 : dy=9
 ; if thrust_orient=5 then dx=60  : dy=80  
 ; if thrust_orient=6 then dx=37  : dy=93
 ; if thrust_orient=7 then dx=98  : dy=18
 ; if thrust_orient=8 then dx=67  : dy=75
 ; return

lookup_dx_dy
  if thrust_orient=1 then dx=1.0 : dy=0.0    ;precalculated (calculated on a PC) acceleration vectors for each angle of rotation modeled in our game environment
  if thrust_orient=2 then dx=0.5 : dy=0.8
  if thrust_orient=3 then dx=0.4 : dy=0.8
  if thrust_orient=4 then dx=1.0 : dy=0.9
  if thrust_orient=5 then dx=0.6 : dy=0.8  
  if thrust_orient=6 then dx=0.3 : dy=0.9
  if thrust_orient=7 then dx=0.9 : dy=0.1
  if thrust_orient=8 then dx=0.6 : dy=0.7
  return

;Most sources I have tried to follow convert the angle to radians before doing cos and sin 
;However, a professional told me this:
;Let's say that STARSHIP has 16 possible angles of movement. Starting from "North", we'll number these 0 through 15. Each angle is 22.5 degrees apart.
;Now, to determine our vector, we're going to always assume a 'length' of one.
;Now, evil geometry says that sin (vector) = opposite over hypotenuse. cos (vector) = adjacent over hypotenuse.
;Thankfully we always know that our hypotenus, at this step, is equal to one. 
;This means that sin(vector) = opposite, which happens to be our "DY". And our cos(vector) happens to be our "DX".
;So, to determine our DX for any given angle, DX = cos(angle). And DY = sin(angle).
;
;That professional also advised to multiply by 100 to loose the decimal places

;I am using ABS (absolute value) here because the sign of dx and dy will be dealt with in the move_ship routine when it gets added or subtracted from the axis values
;Below is what my spreadsheet produced.
;degrees Rot	Cos x	Sin y	ABS(Cos x * 100)=DX	ABS(Sin Y * 100)=DY
;0		1	0	100			0
;45		0.53	0.85	53			85
;90		-0.45	0.89	45			89
;135		-1	0.09	100			9
;180		-0.6	-0.8	60			80
;225		0.37	-0.93	37			93
;270		0.98	-0.18	98			18
;315		0.67	0.75	67			75


move_ship
  ;now the professional says we need to do this
  ;X = X + (DX * THRUST) / 100; // Correct for the pixels used in movement
  ;Y = Y + (DY * THRUST) / 100; // Correct for the pixels used in movement

  ; I am going to say that thrust is always 1 and any number times 1 is itself so then we just need to divide by 100
  ;dx=dx/100   wait, woops the decimal is back and it gets lost if I am not using fixed point numbers so, I am going back and dimension those now
  ;dy=dy/100   and oh, since I am going to add those values to playerx and playery those probably need to be fixed point also.
  ;but if I am going to multiply by 100 in the lookup table and then divide by 100 later why don't I just forget about that step all together and keep the decimal?

  if thrust_orient=1 then playerx=playerx    : playery=playery-dy    ;playerx=playerx is not necessary here but shown in this demo to keep axis pairs readable 
  if thrust_orient=2 then playerx=playerx+dx : playery=playery-dy
  if thrust_orient=3 then playerx=playerx+dx : playery=playery
  if thrust_orient=4 then playerx=playerx+dx : playery=playery+dy
  if thrust_orient=5 then playerx=playerx    : playery=playery+dy 
  if thrust_orient=6 then playerx=playerx-dx : playery=playery+dy
  if thrust_orient=7 then playerx=playerx-dx : playery=playery
  if thrust_orient=8 then playerx=playerx-dx : playery=playery-dy
  return

check_boundary
  if playerx<3 then playerx=3                                      ;checks and limits player coordinates to keep ship on the visible screen
  if playerx>145 then playerx=145
  if playery>170 then playery=170
  if playery<3 then playery=3
  return

display_live_player
  shipo=ship_orient-1  ;shipo is the animation frame index. sprites must be same width and adjacent in memory to index (base 0 so we subtract one here)
  if thrust_enabled=1 then plotsprite sprite_ship1t player_color playerx playery shipo else plotsprite sprite_ship1 player_color playerx playery shipo
  return

